Skip to main content
View Zag.js on Github
Join the Discord server

Collapsible

A collapsible is a component which expands and collapses a panel.

Properties

Features

  • Can be controlled or uncontrolled
  • Works for width and height collapsibles

Installation

To use the collapsible machine in your project, run the following command in your command line:

npm install @zag-js/collapsible @zag-js/solid # or yarn add @zag-js/collapsible @zag-js/solid

Usage

First, import the collapsible package into your project

import * as collapsible from "@zag-js/collapsible"

The collapsible package exports two key functions:

  • machine — The state machine logic for the collapsible widget.
  • connect — The function that translates the machine's state to JSX attributes and event handlers.

You'll also need to provide a unique id to the useMachine hook. This is used to ensure that every part has a unique identifier.

Next, import the required hooks and functions for your framework and use the collapsible machine in your project 🔥

import * as collapsible from "@zag-js/collapsible" import { normalizeProps, useMachine } from "@zag-js/solid" import { createMemo, createUniqueId } from "solid-js" function Collapsible() { const service = useMachine(collapsible.machine, { id: createUniqueId() }) const api = createMemo(() => collapsible.connect(service, normalizeProps)) return ( <div {...api().getRootProps()}> <button {...api().getTriggerProps()}>Collapse Trigger</button> <div {...api().getContentProps()}>Collape Content</div> </div> ) }

Setting the initial state

Pass the defaultOpen machine context property to the machine function to set the initial state.

const service = useMachine(collapsible.machine, { defaultOpen: true, })

Controlled collapsible

To control the open state programmatically, pass the open and onOpenChange properties to the machine function.

import { createSignal } from "solid-js" export function ControlledCollapsible() { const [open, setOpen] = createSignal(false) const service = useMachine(collapsible.machine, { get open() { return open() }, onOpenChange(details) { setOpen(details.open) }, }) return ( // ... ) }

Listening for changes

When the collapsible state changes, the onOpenChange callback is invoked.

const service = useMachine(collapsible.machine, { onOpenChange(details) { // details => { open: boolean } console.log("collapsible open:", details.open) }, })

Disabling the collapsible

Set the disabled machine context property to true to disable the collapsible.

const service = useMachine(collapsible.machine, { disabled: true, })

Animating the collapsible

Use CSS animations to animate the collapsible when it expands and collapses. The --height and --width custom properties are attached to the content part.

@keyframes expand { from { height: 0; } to { height: var(--height); } } @keyframes collapse { from { height: var(--height); } to { height: 0; } } [data-scope="collapsible"][data-part="content"] { overflow: hidden; max-width: 400px; } [data-scope="collapsible"][data-part="content"][data-state="open"] { animation: expand 110ms cubic-bezier(0, 0, 0.38, 0.9); } [data-scope="collapsible"][data-part="content"][data-state="closed"] { animation: collapse 110ms cubic-bezier(0, 0, 0.38, 0.9); }

Styling guide

Earlier, we mentioned that each collapsible part has a data-part attribute added to them to select and style them in the DOM.

Open and closed state

When a collapsible is expanded or collapsed, a data-state attribute is set on the root, trigger and content elements. This attribute is removed when it is closed.

[data-part="root"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ } [data-part="trigger"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ } [data-part="content"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ }

Focused state

When a collapsible's trigger is focused, a data-focus attribute is set on the root, trigger and content.

[data-part="root"][data-focus] { /* styles for the item's focus state */ } [data-part="trigger"][data-focus] { /* styles for the content's focus state */ } [data-part="content"][data-focus] { /* styles for the content's focus state */ }

Collapse animation

The collapsible content provides --width and --height CSS variables that can be used to create smooth animations. These variables are automatically calculated and updated based on the content's dimensions.

[data-scope="collapsible"][data-part="content"][data-state="open"] { animation: slideDown 200ms ease; } [data-scope="collapsible"][data-part="content"][data-state="closed"] { animation: slideUp 200ms ease; } @keyframes slideDown { from { opacity: 0.01; height: 0; } to { opacity: 1; height: var(--height); } } @keyframes slideUp { from { opacity: 1; height: var(--height); } to { opacity: 0.01; height: 0; } }

Methods and Properties

The collapsible's api exposes the following methods and properties:

Machine Context

The collapsible machine exposes the following context properties:

  • idsPartial<{ root: string; content: string; trigger: string; }>The ids of the elements in the collapsible. Useful for composition.
  • openbooleanThe controlled open state of the collapsible.
  • defaultOpenbooleanThe initial open state of the collapsible when rendered. Use when you don't need to control the open state of the collapsible.
  • onOpenChange(details: OpenChangeDetails) => voidThe callback invoked when the open state changes.
  • onExitCompleteVoidFunctionThe callback invoked when the exit animation completes.
  • disabledbooleanWhether the collapsible is disabled.
  • idstringThe unique identifier of the machine.
  • getRootNode() => ShadowRoot | Node | DocumentA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.
  • dir"ltr" | "rtl"The document's text/writing direction.

Machine API

The collapsible api exposes the following methods:

  • openbooleanWhether the collapsible is open.
  • visiblebooleanWhether the collapsible is visible (open or closing)
  • disabledbooleanWhether the collapsible is disabled
  • setOpen(open: boolean) => voidFunction to open or close the collapsible.
  • measureSizeVoidFunctionFunction to measure the size of the content.

Data Attributes

Root
data-scope
collapsible
data-part
root
data-state
"open" | "closed"
Content
data-scope
collapsible
data-part
content
data-state
"open" | "closed"
data-disabled
Present when disabled
Trigger
data-scope
collapsible
data-part
trigger
data-state
"open" | "closed"
data-disabled
Present when disabled
Indicator
data-scope
collapsible
data-part
indicator
data-state
"open" | "closed"
data-disabled
Present when disabled

CSS Variables

Content
--height
The height of the element
--width
The width of the element

Accessibility

Adheres to the Disclosure WAI-ARIA design pattern.

Keyboard Interactions

  • Space
    Opens/closes the collapsible.
  • Enter
    Opens/closes the collapsible.

Edit this page on GitHub

A project by Chakra Systems
Copyright © 2025
On this page

Skip to main content

Collapsible

A collapsible is a component which expands and collapses a panel.

Properties

Features

  • Can be controlled or uncontrolled
  • Works for width and height collapsibles

Installation

To use the collapsible machine in your project, run the following command in your command line:

npm install @zag-js/collapsible @zag-js/svelte # or yarn add @zag-js/collapsible @zag-js/svelte

Usage

First, import the collapsible package into your project

import * as collapsible from "@zag-js/collapsible"

The collapsible package exports two key functions:

  • machine — The state machine logic for the collapsible widget.
  • connect — The function that translates the machine's state to JSX attributes and event handlers.

You'll also need to provide a unique id to the useMachine hook. This is used to ensure that every part has a unique identifier.

Next, import the required hooks and functions for your framework and use the collapsible machine in your project 🔥

<script lang="ts"> import * as collapsible from "@zag-js/collapsible" import { normalizeProps, useMachine } from "@zag-js/svelte" const id = $props.id() const service = useMachine(collapsible.machine, ({ id })) const api = $derived(collapsible.connect(service, normalizeProps)) </script> <div {...api.getRootProps()}> <button {...api.getTriggerProps()}>Collapse Trigger</button> <div {...api.getContentProps()}>Collape Content</div> </div>

Setting the initial state

Pass the defaultOpen machine context property to the machine function to set the initial state.

const service = useMachine(collapsible.machine, { defaultOpen: true, })

Controlled collapsible

To control the open state programmatically, pass the open and onOpenChange properties to the machine function.

<script lang="ts"> let open = $state(false) const service = useMachine(collapsible.machine, { get open() { return open }, onOpenChange(details) { open = details.open }, }) </script>

Listening for changes

When the collapsible state changes, the onOpenChange callback is invoked.

const service = useMachine(collapsible.machine, { onOpenChange(details) { // details => { open: boolean } console.log("collapsible open:", details.open) }, })

Disabling the collapsible

Set the disabled machine context property to true to disable the collapsible.

const service = useMachine(collapsible.machine, { disabled: true, })

Animating the collapsible

Use CSS animations to animate the collapsible when it expands and collapses. The --height and --width custom properties are attached to the content part.

@keyframes expand { from { height: 0; } to { height: var(--height); } } @keyframes collapse { from { height: var(--height); } to { height: 0; } } [data-scope="collapsible"][data-part="content"] { overflow: hidden; max-width: 400px; } [data-scope="collapsible"][data-part="content"][data-state="open"] { animation: expand 110ms cubic-bezier(0, 0, 0.38, 0.9); } [data-scope="collapsible"][data-part="content"][data-state="closed"] { animation: collapse 110ms cubic-bezier(0, 0, 0.38, 0.9); }

Styling guide

Earlier, we mentioned that each collapsible part has a data-part attribute added to them to select and style them in the DOM.

Open and closed state

When a collapsible is expanded or collapsed, a data-state attribute is set on the root, trigger and content elements. This attribute is removed when it is closed.

[data-part="root"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ } [data-part="trigger"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ } [data-part="content"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ }

Focused state

When a collapsible's trigger is focused, a data-focus attribute is set on the root, trigger and content.

[data-part="root"][data-focus] { /* styles for the item's focus state */ } [data-part="trigger"][data-focus] { /* styles for the content's focus state */ } [data-part="content"][data-focus] { /* styles for the content's focus state */ }

Collapse animation

The collapsible content provides --width and --height CSS variables that can be used to create smooth animations. These variables are automatically calculated and updated based on the content's dimensions.

[data-scope="collapsible"][data-part="content"][data-state="open"] { animation: slideDown 200ms ease; } [data-scope="collapsible"][data-part="content"][data-state="closed"] { animation: slideUp 200ms ease; } @keyframes slideDown { from { opacity: 0.01; height: 0; } to { opacity: 1; height: var(--height); } } @keyframes slideUp { from { opacity: 1; height: var(--height); } to { opacity: 0.01; height: 0; } }

Methods and Properties

The collapsible's api exposes the following methods and properties:

Machine Context

The collapsible machine exposes the following context properties:

  • idsPartial<{ root: string; content: string; trigger: string; }>The ids of the elements in the collapsible. Useful for composition.
  • openbooleanThe controlled open state of the collapsible.
  • defaultOpenbooleanThe initial open state of the collapsible when rendered. Use when you don't need to control the open state of the collapsible.
  • onOpenChange(details: OpenChangeDetails) => voidThe callback invoked when the open state changes.
  • onExitCompleteVoidFunctionThe callback invoked when the exit animation completes.
  • disabledbooleanWhether the collapsible is disabled.
  • idstringThe unique identifier of the machine.
  • getRootNode() => ShadowRoot | Node | DocumentA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.
  • dir"ltr" | "rtl"The document's text/writing direction.

Machine API

The collapsible api exposes the following methods:

  • openbooleanWhether the collapsible is open.
  • visiblebooleanWhether the collapsible is visible (open or closing)
  • disabledbooleanWhether the collapsible is disabled
  • setOpen(open: boolean) => voidFunction to open or close the collapsible.
  • measureSizeVoidFunctionFunction to measure the size of the content.

Data Attributes

Root
data-scope
collapsible
data-part
root
data-state
"open" | "closed"
Content
data-scope
collapsible
data-part
content
data-state
"open" | "closed"
data-disabled
Present when disabled
Trigger
data-scope
collapsible
data-part
trigger
data-state
"open" | "closed"
data-disabled
Present when disabled
Indicator
data-scope
collapsible
data-part
indicator
data-state
"open" | "closed"
data-disabled
Present when disabled

CSS Variables

Content
--height
The height of the element
--width
The width of the element

Accessibility

Adheres to the Disclosure WAI-ARIA design pattern.

Keyboard Interactions

  • Space
    Opens/closes the collapsible.
  • Enter
    Opens/closes the collapsible.
Edit this page on GitHub

Skip to main content
View Zag.js on Github
Join the Discord server

Collapsible

A collapsible is a component which expands and collapses a panel.

Properties

Features

  • Can be controlled or uncontrolled
  • Works for width and height collapsibles

Installation

To use the collapsible machine in your project, run the following command in your command line:

npm install @zag-js/collapsible @zag-js/react # or yarn add @zag-js/collapsible @zag-js/react

Usage

First, import the collapsible package into your project

import * as collapsible from "@zag-js/collapsible"

The collapsible package exports two key functions:

  • machine — The state machine logic for the collapsible widget.
  • connect — The function that translates the machine's state to JSX attributes and event handlers.

You'll also need to provide a unique id to the useMachine hook. This is used to ensure that every part has a unique identifier.

Next, import the required hooks and functions for your framework and use the collapsible machine in your project 🔥

import * as collapsible from "@zag-js/collapsible" import { normalizeProps, useMachine } from "@zag-js/react" import { useId } from "react" function Collapsible() { const service = useMachine(collapsible.machine, { id: useId() }) const api = collapsible.connect(service, normalizeProps) return ( <div {...api.getRootProps()}> <button {...api.getTriggerProps()}>Collapse Trigger</button> <div {...api.getContentProps()}>Collape Content</div> </div> ) }

Setting the initial state

Pass the defaultOpen machine context property to the machine function to set the initial state.

const service = useMachine(collapsible.machine, { defaultOpen: true, })

Controlled collapsible

To control the open state programmatically, pass the open and onOpenChange properties to the machine function.

import { useState } from "react" export function ControlledCollapsible() { const [open, setOpen] = useState(false) const service = useMachine(collapsible.machine, { open, onOpenChange(details) { setOpen(details.open) } }) return ( // ... ) }

Listening for changes

When the collapsible state changes, the onOpenChange callback is invoked.

const service = useMachine(collapsible.machine, { onOpenChange(details) { // details => { open: boolean } console.log("collapsible open:", details.open) }, })

Disabling the collapsible

Set the disabled machine context property to true to disable the collapsible.

const service = useMachine(collapsible.machine, { disabled: true, })

Animating the collapsible

Use CSS animations to animate the collapsible when it expands and collapses. The --height and --width custom properties are attached to the content part.

@keyframes expand { from { height: 0; } to { height: var(--height); } } @keyframes collapse { from { height: var(--height); } to { height: 0; } } [data-scope="collapsible"][data-part="content"] { overflow: hidden; max-width: 400px; } [data-scope="collapsible"][data-part="content"][data-state="open"] { animation: expand 110ms cubic-bezier(0, 0, 0.38, 0.9); } [data-scope="collapsible"][data-part="content"][data-state="closed"] { animation: collapse 110ms cubic-bezier(0, 0, 0.38, 0.9); }

Styling guide

Earlier, we mentioned that each collapsible part has a data-part attribute added to them to select and style them in the DOM.

Open and closed state

When a collapsible is expanded or collapsed, a data-state attribute is set on the root, trigger and content elements. This attribute is removed when it is closed.

[data-part="root"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ } [data-part="trigger"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ } [data-part="content"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ }

Focused state

When a collapsible's trigger is focused, a data-focus attribute is set on the root, trigger and content.

[data-part="root"][data-focus] { /* styles for the item's focus state */ } [data-part="trigger"][data-focus] { /* styles for the content's focus state */ } [data-part="content"][data-focus] { /* styles for the content's focus state */ }

Collapse animation

The collapsible content provides --width and --height CSS variables that can be used to create smooth animations. These variables are automatically calculated and updated based on the content's dimensions.

[data-scope="collapsible"][data-part="content"][data-state="open"] { animation: slideDown 200ms ease; } [data-scope="collapsible"][data-part="content"][data-state="closed"] { animation: slideUp 200ms ease; } @keyframes slideDown { from { opacity: 0.01; height: 0; } to { opacity: 1; height: var(--height); } } @keyframes slideUp { from { opacity: 1; height: var(--height); } to { opacity: 0.01; height: 0; } }

Methods and Properties

The collapsible's api exposes the following methods and properties:

Machine Context

The collapsible machine exposes the following context properties:

  • idsPartial<{ root: string; content: string; trigger: string; }>The ids of the elements in the collapsible. Useful for composition.
  • openbooleanThe controlled open state of the collapsible.
  • defaultOpenbooleanThe initial open state of the collapsible when rendered. Use when you don't need to control the open state of the collapsible.
  • onOpenChange(details: OpenChangeDetails) => voidThe callback invoked when the open state changes.
  • onExitCompleteVoidFunctionThe callback invoked when the exit animation completes.
  • disabledbooleanWhether the collapsible is disabled.
  • idstringThe unique identifier of the machine.
  • getRootNode() => ShadowRoot | Node | DocumentA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.
  • dir"ltr" | "rtl"The document's text/writing direction.

Machine API

The collapsible api exposes the following methods:

  • openbooleanWhether the collapsible is open.
  • visiblebooleanWhether the collapsible is visible (open or closing)
  • disabledbooleanWhether the collapsible is disabled
  • setOpen(open: boolean) => voidFunction to open or close the collapsible.
  • measureSizeVoidFunctionFunction to measure the size of the content.

Data Attributes

Root
data-scope
collapsible
data-part
root
data-state
"open" | "closed"
Content
data-scope
collapsible
data-part
content
data-state
"open" | "closed"
data-disabled
Present when disabled
Trigger
data-scope
collapsible
data-part
trigger
data-state
"open" | "closed"
data-disabled
Present when disabled
Indicator
data-scope
collapsible
data-part
indicator
data-state
"open" | "closed"
data-disabled
Present when disabled

CSS Variables

Content
--height
The height of the element
--width
The width of the element

Accessibility

Adheres to the Disclosure WAI-ARIA design pattern.

Keyboard Interactions

  • Space
    Opens/closes the collapsible.
  • Enter
    Opens/closes the collapsible.

Edit this page on GitHub

A project by Chakra Systems
Copyright © 2025
On this page

Skip to main content
View Zag.js on Github
Join the Discord server

Collapsible

A collapsible is a component which expands and collapses a panel.

Properties

Features

  • Can be controlled or uncontrolled
  • Works for width and height collapsibles

Installation

To use the collapsible machine in your project, run the following command in your command line:

npm install @zag-js/collapsible @zag-js/vue # or yarn add @zag-js/collapsible @zag-js/vue

Usage

First, import the collapsible package into your project

import * as collapsible from "@zag-js/collapsible"

The collapsible package exports two key functions:

  • machine — The state machine logic for the collapsible widget.
  • connect — The function that translates the machine's state to JSX attributes and event handlers.

You'll also need to provide a unique id to the useMachine hook. This is used to ensure that every part has a unique identifier.

Next, import the required hooks and functions for your framework and use the collapsible machine in your project 🔥

<script setup> import * as collapsible from "@zag-js/collapsible" import { normalizeProps, useMachine } from "@zag-js/vue" import { computed } from "vue" const service = useMachine(collapsible.machine, { id: "1" }) const api = computed(() => collapsible.connect(service, normalizeProps)) </script> <template> <div v-bind="api.getRootProps()"> <button v-bind="api.getTriggerProps()">Collapse Trigger</button> <div v-bind="api.getContentProps()">Collapse Content</div> </div> </template>

Setting the initial state

Pass the defaultOpen machine context property to the machine function to set the initial state.

const service = useMachine(collapsible.machine, { defaultOpen: true, })

Controlled collapsible

To control the open state programmatically, pass the open and onOpenChange properties to the machine function.

<script setup lang="ts"> import { ref } from "vue" const openRef = ref(false) const service = useMachine(collapsible.machine, { get open() { return openRef.value }, onOpenChange(details) { openRef.value = details.open }, }) </script>

Listening for changes

When the collapsible state changes, the onOpenChange callback is invoked.

const service = useMachine(collapsible.machine, { onOpenChange(details) { // details => { open: boolean } console.log("collapsible open:", details.open) }, })

Disabling the collapsible

Set the disabled machine context property to true to disable the collapsible.

const service = useMachine(collapsible.machine, { disabled: true, })

Animating the collapsible

Use CSS animations to animate the collapsible when it expands and collapses. The --height and --width custom properties are attached to the content part.

@keyframes expand { from { height: 0; } to { height: var(--height); } } @keyframes collapse { from { height: var(--height); } to { height: 0; } } [data-scope="collapsible"][data-part="content"] { overflow: hidden; max-width: 400px; } [data-scope="collapsible"][data-part="content"][data-state="open"] { animation: expand 110ms cubic-bezier(0, 0, 0.38, 0.9); } [data-scope="collapsible"][data-part="content"][data-state="closed"] { animation: collapse 110ms cubic-bezier(0, 0, 0.38, 0.9); }

Styling guide

Earlier, we mentioned that each collapsible part has a data-part attribute added to them to select and style them in the DOM.

Open and closed state

When a collapsible is expanded or collapsed, a data-state attribute is set on the root, trigger and content elements. This attribute is removed when it is closed.

[data-part="root"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ } [data-part="trigger"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ } [data-part="content"][data-state="open|closed"] { /* styles for the collapsible is open or closed state */ }

Focused state

When a collapsible's trigger is focused, a data-focus attribute is set on the root, trigger and content.

[data-part="root"][data-focus] { /* styles for the item's focus state */ } [data-part="trigger"][data-focus] { /* styles for the content's focus state */ } [data-part="content"][data-focus] { /* styles for the content's focus state */ }

Collapse animation

The collapsible content provides --width and --height CSS variables that can be used to create smooth animations. These variables are automatically calculated and updated based on the content's dimensions.

[data-scope="collapsible"][data-part="content"][data-state="open"] { animation: slideDown 200ms ease; } [data-scope="collapsible"][data-part="content"][data-state="closed"] { animation: slideUp 200ms ease; } @keyframes slideDown { from { opacity: 0.01; height: 0; } to { opacity: 1; height: var(--height); } } @keyframes slideUp { from { opacity: 1; height: var(--height); } to { opacity: 0.01; height: 0; } }

Methods and Properties

The collapsible's api exposes the following methods and properties:

Machine Context

The collapsible machine exposes the following context properties:

  • idsPartial<{ root: string; content: string; trigger: string; }>The ids of the elements in the collapsible. Useful for composition.
  • openbooleanThe controlled open state of the collapsible.
  • defaultOpenbooleanThe initial open state of the collapsible when rendered. Use when you don't need to control the open state of the collapsible.
  • onOpenChange(details: OpenChangeDetails) => voidThe callback invoked when the open state changes.
  • onExitCompleteVoidFunctionThe callback invoked when the exit animation completes.
  • disabledbooleanWhether the collapsible is disabled.
  • idstringThe unique identifier of the machine.
  • getRootNode() => ShadowRoot | Node | DocumentA root node to correctly resolve document in custom environments. E.x.: Iframes, Electron.
  • dir"ltr" | "rtl"The document's text/writing direction.

Machine API

The collapsible api exposes the following methods:

  • openbooleanWhether the collapsible is open.
  • visiblebooleanWhether the collapsible is visible (open or closing)
  • disabledbooleanWhether the collapsible is disabled
  • setOpen(open: boolean) => voidFunction to open or close the collapsible.
  • measureSizeVoidFunctionFunction to measure the size of the content.

Data Attributes

Root
data-scope
collapsible
data-part
root
data-state
"open" | "closed"
Content
data-scope
collapsible
data-part
content
data-state
"open" | "closed"
data-disabled
Present when disabled
Trigger
data-scope
collapsible
data-part
trigger
data-state
"open" | "closed"
data-disabled
Present when disabled
Indicator
data-scope
collapsible
data-part
indicator
data-state
"open" | "closed"
data-disabled
Present when disabled

CSS Variables

Content
--height
The height of the element
--width
The width of the element

Accessibility

Adheres to the Disclosure WAI-ARIA design pattern.

Keyboard Interactions

  • Space
    Opens/closes the collapsible.
  • Enter
    Opens/closes the collapsible.

Edit this page on GitHub

A project by Chakra Systems
Copyright © 2025
On this page